# coding: utf-8

"""
    Model compatible to kubernetes client generated with swagger

"""

from pprint import pformat
from six import iteritems


class V1CertificateConfiguration(object):
    swagger_types = {
        'api_version': 'str',
        # use 'object' type because kubernetes ApiClient
        # cannot deserialize objects using external types
        'spec': 'object',
        'kind': 'str',
        'metadata': 'V1ObjectMeta',
        'status': 'object',
    }

    attribute_map = {
        'api_version': 'apiVersion',
        'spec': 'spec',
        'kind': 'kind',
        'metadata': 'metadata',
        'status': 'status'
    }

    def __init__(self, api_version=None, kind=None,
                 metadata=None, spec=None, status=None, events=None):
        self._api_version = None
        self._spec = None
        self._kind = None
        self._metadata = None
        self._status = None
        self._events = None
        self.discriminator = None

        if api_version is not None:
            self.api_version = api_version
        if spec is not None:
            self.spec = spec
        if kind is not None:
            self.kind = kind
        if metadata is not None:
            self.metadata = metadata
        if status is not None:
            self.status = status
        if events is not None:
            self.events = events

    @property
    def api_version(self):
        return self._api_version

    @api_version.setter
    def api_version(self, api_version):
        self._api_version = api_version

    @property
    def spec(self):
        return self._spec

    @spec.setter
    def spec(self, spec):
        self._spec = spec

    @property
    def kind(self):
        return self._kind

    @kind.setter
    def kind(self, kind):
        self._kind = kind

    @property
    def metadata(self):
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        self._metadata = metadata

    @property
    def status(self):
        return self._status

    @status.setter
    def status(self, status):
        self._status = status

    @property
    def events(self):
        return self._events

    @events.setter
    def events(self, events):
        self._events = events

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if isinstance(other, V1CertificateConfiguration):
            return self._metadata['Generation'] == other._metadata['Generation']

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
