#!/usr/bin/env bash

#phys-429	KaaS Management cluster
#	vm-21
#	vm-22
#	vm-23
#	Managed cluster - control plane
#	vm-24
#	vm-25
#	vm-26
#	Managed cluster - ceph
#	vm-27
#	vm-28
#	vm-29
#	Managed cluster - stacklight
#	vm-30
#	vm-31
#	vm-32
#	Managed cluster - worker/storage
#	vm-33
#	vm-34
#	vm-35
#	vm-36
#	vm-37
#	vm-38
echo 'set_power'

ipmi_password="password"

function set_power(){
  local action=${1:-'status'}
  local nset=${2:-'all'}
  declare -A nodes=();
  declare -A nodes_child=();
  declare -A nodes_mgmt=();

  nodes_child=(\
[vm-24]='172.18.168.13' \
[vm-25]='172.18.168.13' \
[vm-26]='172.18.168.13' \
[vm-27]='172.18.168.13' \
[vm-28]='172.18.168.13' \
[vm-29]='172.18.168.13' \
[vm-30]='172.18.168.13' \
[vm-31]='172.18.168.13' \
[vm-32]='172.18.168.13' \
[vm-33]='172.18.168.13' \
[vm-34]='172.18.168.13' \
[vm-35]='172.18.168.13' \
[vm-36]='172.18.168.13' \
[vm-37]='172.18.168.13' \
[vm-38]='172.18.168.13')
  ports_child=(\
[vm-24]='10024' \
[vm-25]='10025' \
[vm-26]='10026' \
[vm-27]='10027' \
[vm-28]='10028' \
[vm-29]='10029' \
[vm-30]='10030' \
[vm-31]='10031' \
[vm-32]='10032' \
[vm-33]='10033' \
[vm-34]='10034' \
[vm-35]='10035' \
[vm-36]='10036' \
[vm-37]='10037' \
[vm-38]='10038')

  nodes_mgmt=(\
[vm-21]='172.18.168.13' \
[vm-22]='172.18.168.13' \
[vm-23]='172.18.168.13')
  ports_mgmt=(\
[vm-21]='10021' \
[vm-22]='10022' \
[vm-23]='10023' \

  # awesome merge event...
  case "$nset" in
      'mgmt')
        for i in ${!nodes_mgmt[@]}; do
            nodes[$i]="${nodes_mgmt[$i]}"
        done
      ;;
      'child')
        for i in ${!nodes_child[@]}; do
            nodes[$i]="${nodes_child[$i]}"
        done
      ;;
      'all')
        for i in ${!nodes_child[@]}; do
            nodes[$i]="${nodes_child[$i]}"
        done
        for i in ${!nodes_mgmt[@]}; do
            nodes[$i]="${nodes_mgmt[$i]}"
        done
      ;;
  esac

  for i in "${!nodes[@]}"; do
    echo "node: $i"
    set -xe
    ipmitool -I lanplus -H ${nodes[$i]} -p ${ports[$i]} -U admin -P "${ipmi_password}" chassis power $action
    set +xe
  done
 }

