#!/usr/bin/env bash

#phys-429	KaaS Management cluster
#	vm-1
#	vm-2
#	vm-3
#	Managed cluster - control plane
#	vm-4
#	vm-5
#	vm-6
#	Managed cluster - ceph
#	vm-7
#	vm-8
#	vm-9
#	Managed cluster - stacklight
#	vm-10
#	vm-11
#	vm-12
#	Managed cluster - worker/storage
#	vm-13
#	vm-14
#	vm-15
#	vm-16
#	vm-17
#	vm-18
echo 'set_power'

ipmi_password="password"

function set_power(){
  local action=${1:-'status'}
  local nset=${2:-'all'}
  declare -A nodes=();
  declare -A ports=();
  declare -A nodes_child=();
  declare -A nodes_mgmt=();

  nodes_child=(\
[vm-4]='172.18.168.13' \
[vm-5]='172.18.168.13' \
[vm-6]='172.18.168.13' \
[vm-7]='172.18.168.13' \
[vm-8]='172.18.168.13' \
[vm-9]='172.18.168.13' \
[vm-10]='172.18.168.13' \
[vm-11]='172.18.168.13' \
[vm-12]='172.18.168.13' \
[vm-13]='172.18.168.13' \
[vm-14]='172.18.168.13' \
[vm-15]='172.18.168.13' \
[vm-16]='172.18.168.13' \
[vm-17]='172.18.168.13' \
[vm-18]='172.18.168.13')
  ports_child=(\
[vm-4]='10004' \
[vm-5]='10005' \
[vm-6]='10006' \
[vm-7]='10007' \
[vm-8]='10008' \
[vm-9]='10009' \
[vm-10]='10010' \
[vm-11]='10011' \
[vm-12]='10012' \
[vm-13]='10013' \
[vm-14]='10014' \
[vm-15]='10015' \
[vm-16]='10016' \
[vm-17]='10017' \
[vm-18]='10018')

  nodes_mgmt=(\
[vm-1]='172.18.168.13' \
[vm-2]='172.18.168.13' \
[vm-3]='172.18.168.13')
  ports_mgmt=(\
[vm-1]='10001' \
[vm-2]='10002' \
[vm-3]='10003' \

  # awesome merge event...
  case "$nset" in
      'mgmt')
        for i in ${!nodes_mgmt[@]}; do
            nodes[$i]="${nodes_mgmt[$i]}"
            ports[$i]="${ports_mgmt[$i]}"
        done
      ;;
      'child')
        for i in ${!nodes_child[@]}; do
            nodes[$i]="${nodes_child[$i]}"
            ports[$i]="${ports_child[$i]}"
        done
      ;;
      'all')
        for i in ${!nodes_child[@]}; do
            nodes[$i]="${nodes_child[$i]}"
            ports[$i]="${ports_child[$i]}"
        done
        for i in ${!nodes_mgmt[@]}; do
            nodes[$i]="${nodes_mgmt[$i]}"
            ports[$i]="${ports_mgmt[$i]}"
        done
      ;;
  esac

  for i in "${!nodes[@]}"; do
    echo "node: $i"
    set -xe
    ipmitool -I lanplus -H ${nodes[$i]} -p ${ports[$i]} -U admin -P "${ipmi_password}" chassis power $action
    set +xe
  done
}
