import pytest

from si_tests import logger
from si_tests import settings


LOG = logger.logger


@pytest.mark.parametrize("_", ["CLUSTER_NAME={0}"
                               .format(settings.TARGET_CLUSTER)])
def test_k8s_rally(kaas_manager, rally_manager, _):

    LOG.info("Starting rally pod")
    pod = rally_manager.run_tests()
    LOG.info("Waiting for results ...")
    rally_manager.wait_test_results(
        pod=pod, timeout=settings.RALLY_WAIT_TIMEOUT
    )
    rally_manager.download_test_results(pod)
    k8s_rally_pass = rally_manager.check_test_results(pod)

    # Checking all pods are in consistent state after test run
    ns = kaas_manager.get_namespace(namespace=settings.TARGET_NAMESPACE)
    cluster = ns.get_cluster(settings.TARGET_CLUSTER)
    cluster.check.check_k8s_pods()

    if settings.RALLY_CHECK_RESULTS:
        assert k8s_rally_pass,  "Some of k8s rally tests failed"
